<template>
  <div
    v-if="!providers.IsHidden || !payments.IsHidden || manus.length || !introduce.IsHidden || !introduceContent.IsHidden || !copyright.IsHidden"
    :class="[
      { 'bg-background3 w-full': !widthCustomizeEnabled },
      { 'header-full-width-content': isFullIframe },
      { 'max-lg:h-[485px]': copyright.IsHidden },
      { 'max-lg:h-[557px]': !copyright.IsHidden },
      'mt-auto mx-auto --text3 peru-footer-container',
    ]"
  >
    <div class="bottom-divider"></div>
    <div
      :class="[
        widthCustomizeEnabled
          ? 'w-[var(--default-width)]'
          : 'w-full footer-container margin_auto',
        `text-${alignment}`,
      ]"
    >
      <div
        v-if="!providers.IsHidden"
        :class="[informationEnabled ? 'py-[24px]' : 'py-6', 'border-b']"
      >
        <p v-if="informationEnabled" class="text-sm leading-4">{{ providers.Text }}</p>
        <div
          :class="[
            informationEnabled ? 'mt-4' : '',
            `flex items-center justify-${alignment}`,
          ]"
        >
          <div class="h-[27.47px]">
            <img :src="providers.ImagePath" class="object-contain h-full" />
          </div>
        </div>
      </div>
      <div
        v-if="!payments.IsHidden"
        :class="[informationEnabled ? 'py-[24px]' : 'py-6', 'border-b']"
      >
        <p v-if="informationEnabled" class="text-sm leading-4">{{ payments.Text }}</p>
        <div
          :class="[
            informationEnabled ? 'mt-4' : '',
            `flex items-center justify-${alignment}`,
          ]"
        >
          <div class="h-[27.47px]">
            <img :src="payments.ImagePath" class="object-contain h-full" />
          </div>
        </div>
      </div>
      <div
        v-if="manus.length"
        :class="[
          informationEnabled ? 'py-[24px] border-b' : 'py-3.5',
          `contact-us items-center justify-${alignment}`,
        ]"
        class="peru-footer-links"
      >
        <div
          v-for="(manu, index) in manus.slice(0, 7)"
          :key="manu"
          class="flex items-center text-sm leading-4 peru-footer-link"
        >
          <nuxt-link :to="manu.HyperLink">{{ manu.Text }}</nuxt-link>
        </div>
      </div>
      <div v-if="manus.length" class="border-b py-4 peru-footer-help-center-link">
        <nuxt-link to="/help-center" class="text-sm leading-4 text-[var(--text3)]">
          <span class="flex justify-between items-center">
            <span>{{ $t("help_center") }}</span>
            <div class="flex items-center m-angle-right-container opacity-20">
              <font-awesome-icon icon="angle-right" class="icon-angle-right" />
            </div>
          </span>
        </nuxt-link>
      </div>
      <div
        v-if="informationEnabled && !introduce.IsHidden"
        :class="[informationEnabled ? 'py-[24px]' : 'py-6', 'border-b --text3']"
      >
        <h2 class="mb-2 leading-4">{{ introduce.Text }}</h2>
        <div
          v-if="!introduceContent.IsHidden"
          :class="[
            checkTextLength ? (isReadMore ? 'h-14' : '') : '',
            'truncate leading-7 --text3',
          ]"
          v-html="introduceContent.Text"
        ></div>
        <div
          v-if="checkTextLength"
          class="mt-2 underline cursor-pointer --text3 text-[12px] font-[700] leading-[14px]"
          @click="isReadMore = !isReadMore"
        >
          {{ isReadMore ? "Read More" : "Hide Information" }}
        </div>
      </div>
      <div v-if="!copyright.IsHidden" class="py-[24px]">
        <div class="flex justify-center">
          <p class="text-[12px]">
            {{ copyright.Text }}
          </p>
        </div>
      </div>
    </div>
  </div>
  <template v-else>
    <div v-if="isShowMobileBottomMenu" class="h-[52px]"></div>
  </template>
  <footer-mobile v-if="isShowMobileBottomMenu" class="mobile-style" :auth="authentication" />
</template>

<script lang="ts">
import footerMobile from "@/components/theme/desktop/peru/components/m-footer-function-1.client.vue";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import EnumAlignment from "@/models/enums/enumAlignment";
import { store } from "@/store";
import commonHelper from "@/utils/commonHelper";
import themePropertyHelper from "@/utils/themePropertyHelper";
import _ from "lodash";
import { PropType, computed, defineComponent, ref } from "vue";

export default defineComponent({
  name: "FooterWebsiteInformation",
  components: {
    footerMobile,
  },
  props: {
    widthCustomizeEnabled: {
      type: Boolean,
      default: false,
    },
    alignment: {
      type: String as PropType<EnumAlignment>,
      default: EnumAlignment.Left,
      required: true,
    },
    informationEnabled: {
      type: Boolean,
      default: false,
    },
    propertyKeys: {
      type: Array as PropType<Array<string>>,
      required: true,
    },
  },
  setup(props) {
    const isReadMore = ref(true);
    const properties = computed(() => props.propertyKeys);
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const selectedThemeName = computed(() => store.state.selectedThemeName);

    const providers = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          properties.value[0]
        )
    );
    const payments = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          properties.value[1]
        )
    );
    const manus = computed(
      (): Array<IThemePropertiesFromApi> =>
        themePropertyHelper.getMultipleThemesProperties(
          themeProperties.value,
          properties.value[2]
        )
    );
    const introduce = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          properties.value[3]
        )
    );
    const introduceContent = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          properties.value[4]
        )
    );
    const copyright = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          properties.value[5]
        )
    );
    const checkTextLength = ref(false);
    if (
      introduceContent.value !== undefined &&
      introduceContent.value.Text.length > 650
    ) {
      checkTextLength.value = true;
    }

    const contactUsAvailable = computed(
      (): Array<IThemePropertiesFromApi> =>
        themePropertyHelper
          .getMultipleThemesProperties(themeProperties.value, "contact_us_")
          .filter(
            (item) =>
              !item.HtmlId.match(/[0-9]+$/) && !item.HtmlId.includes("_qr_code")
          )
    );
    const { getAssetImage, handleHyperlinkRender } = commonHelper;
    const route = useRoute();
    const isFullIframe: Ref<boolean> = ref(
      _.find(["saba", "digi"], (item: string) =>
        _.includes(_.toLower(String(route.query.provider)), item)
      ) !== undefined
    );
    watch(route, () => {
      isFullIframe.value =
        _.find(["saba", "digi"], (item: string) =>
          _.includes(_.toLower(String(route.query.provider)), item)
        ) !== undefined;
    });
    const authentication = computed(() => store.state.auth);
    const isWebId2625 = store.state.webId === 2625;
    const config = useRuntimeConfig();
    const isDemo = config.public.CURRENTLY_ENV === "demo";
    const isShowMobileBottomMenu = !(isDemo && isWebId2625);
    return {
      isReadMore,
      payments,
      providers,
      copyright,
      manus,
      introduce,
      introduceContent,
      selectedThemeName,
      checkTextLength,
      contactUsAvailable,
      handleHyperlinkRender,
      getAssetImage,
      isFullIframe,
      authentication,
      isShowMobileBottomMenu,
    };
  },
});
</script>
<style lang="scss">
@import url("https://fonts.googleapis.com/css2?family=Roboto&display=swap");
.margin_auto {
  margin: auto;
}
.truncate.leading-7,
.truncate.leading-7 p {
  white-space: normal;
  font-size: 12px;
  font-family: "Roboto", sans-serif;
  font-weight: 400;
  line-height: 14px;
  color: var(--text);
}
.truncate.leading-7.font-black-theme p {
  font-size: 14px;
}
.truncate.leading-7.font-black-theme strong {
  font-size: 14px;
  color: var(--text5);
  font-weight: 700;
  margin: 1px 0 -7px;
  display: block;
}
@media only screen and (min-width: 320px) {
  .contact-us {
    display: block;
  }
}
@media only screen and (min-width: 640px) {
  .margin_auto {
    margin: auto;
  }
  .contact-us {
    display: flex;
  }
}
@media screen and (min-width: 1024px) {
  .footer-menu.mobile-style {
    display: none;
  }
  .mobile-style {
    display: none;
  }
}
@media only screen and (max-width: 1023px) {
  .mobile-style {
    display: flex;
  }
}
@media only screen and (min-width: 1280px) {
  .contact-us {
    display: flex;
  }
  .mobile-style {
    display: none;
  }
}
// @media only screen and (max-width: 640px) {
//   .footer-container {
//     display: none;
//   }
// }
@media only screen and (min-width: 1536px) {
  .contact-us {
    display: flex;
  }
  .mobile-style {
    display: none;
  }
}
.peru-footer-links {
  display: flex;
  flex-wrap: wrap;
  @media screen and (max-width: 639px) {
    display: none;
  }
}
.peru-footer-link:not(:last-of-type)::after {
  content: "|";
  position: relative;
  margin: 0 0.5rem;
}
.peru-footer-container {
  @media screen and (max-width: 319px) {
    padding: 0.5rem;
  }
}
.peru-footer-help-center-link {
  display: none;
  @media screen and (max-width: 639px) {
    display: block;
  }
}
</style>
